﻿Public Class Form2
    Friend Enum VIEWINFO As Integer
        Header = 0  ' ヘッダー情報の表示.
        All = 1     ' 全データの表示.
    End Enum

    Friend IntFrd_ViewInfo As VIEWINFO

    #Region "Sub Form2_Load : Loadイベント."
        Private Sub Form2_Load( ByVal sender As System.Object, _
                                ByVal e As System.EventArgs _
                                ) Handles MyBase.Load
            Try
                ' 削除していません.
                BlnPub_Delete = False
                ' ヘッダーの場合に一部コントロールを使用不可にします.
                If IntFrd_ViewInfo = VIEWINFO.Header Then
                    Me.Panel2.Enabled = False
                    Me.Btn_Delete.Enabled = False
                End If

                ' 送信経緯.
                With Me.Cmb_Received
                    .Items.Clear

                    If Not (ClsPub_HeaderInfo.Received Is Nothing) Then
                        For Int_Loop As Integer = 0 To ClsPub_HeaderInfo.Received.Length - 1
                            .Items.Add(ClsPub_HeaderInfo.Received(Int_Loop))
                        Next Int_Loop
                    End If
                End With
                Dim Str_Name As String = Nothing    ' 名前.
                Dim Str_Address As String = Nothing ' アドレス.

                With ClsPub_HeaderInfo
                    ' 差出人の設定.
                        If Not (.From Is Nothing) Then
                            If Not String.IsNullOrEmpty(.From.Name) Then
                                Str_Name = .From.Name
                            End If
                            If Not String.IsNullOrEmpty(.From.Address) Then
                                Str_Address = .From.Address
                            End If
                        End If

                        Me.Lbl_FromName.Text = Str_Name
                        Me.Lbl_FromAddress.Text = Str_Address
                    ' 宛名(To)の設定.
                        Str_Name = ""
                        Str_Address = ""
                        If Not (.ToAddress Is Nothing) Then
                            For Int_Loop As Integer = 0 To .ToAddress.Length - 1
                                If Int_Loop <> 0 Then
                                    Str_Name &= "; "
                                End If
                                Str_Name &= .ToAddress(Int_Loop).Name
                            Next Int_Loop

                            For Int_Loop As Integer = 0 To .ToAddress.Length - 1
                                If Int_Loop <> 0 Then
                                    Str_Address &= "; "
                                End If
                                Str_Address &= .ToAddress(Int_Loop).Address
                            Next Int_Loop
                        End If
                        Me.Lbl_ToName.Text = Str_Name
                        Me.Lbl_ToAddress.Text = Str_Address
                    ' 宛名(Cc)の設定.
                        Str_Name = ""
                        Str_Address = ""
                        If Not (.CcAddress Is Nothing) Then
                            For Int_Loop As Integer = 0 To .CcAddress.Length - 1
                                If Int_Loop <> 0 Then
                                    Str_Name &= "; "
                                End If
                                Str_Name &= .CcAddress(Int_Loop).Name
                            Next Int_Loop

                            For Int_Loop As Integer = 0 To .CcAddress.Length - 1
                                If Int_Loop <> 0 Then
                                    Str_Address &= "; "
                                End If
                                Str_Address &= .CcAddress(Int_Loop).Address
                            Next Int_Loop
                        End If
                        Me.Lbl_CcName.Text = Str_Name
                        Me.Lbl_CcAddress.Text = Str_Address
                    ' 件名.
                        Me.Lbl_SubjectData.Text = .Subject
                    ' 送信日時.
                        Me.Lbl_SenderDayData.Text = "なし"
                        If .SendDate <> Nothing Then
                            Me.Lbl_SenderDayData.Text = Format(.SendDate, "yyyy/MM/dd (ddd) HH:mm")
                        End If
                    ' 添付ファイル名.
                        Dim Str_Attachments As String = Nothing
                        If Not (.AttachmentName Is Nothing) Then
                            For Int_Loop As Integer = 0 To .AttachmentName.Length - 1
                                If Str_Attachments <> Nothing Then
                                    Str_Attachments &= ControlChars.CrLf
                                End If
                                Str_Attachments &= .AttachmentName(Int_Loop)
                            Next Int_Loop
                        End If
                        Me.Txt_Attachments.Text = Str_Attachments
                    ' 本文.
                        If IntFrd_ViewInfo = VIEWINFO.All Then
                            Me.Txt_Body.Text = ClsPub_Text
                        End If
                End With
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Delete_Click : サーバーから削除."
        Private Sub Btn_Delete_Click( ByVal sender As System.Object, _
                                      ByVal e As System.EventArgs _
                                      ) Handles Btn_Delete.Click
            Try
                Dim Str_Msg As String = "サーバーのメッセージを削除します。" _
                                        & ControlChars.CrLf _
                                        & "削除すると元に戻せません。" _
                                        & ControlChars.CrLf _
                                        & "本当によろしいですか？"
                If MsgBox(Str_Msg, MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                    Dim Cls_SHeader As New NSDPOP3.POP3_SIMPLE_HEADER_INFO
                    Cls_SHeader.MessegeID = ClsPub_HeaderInfo.MassegeID
                    If ClsPub_POP3.DeleteMessage(Cls_SHeader) Then
                        BlnPub_Delete = True
                        MsgBox("データを削除しました。")
                        Me.Close
                    Else
                        ' エラー.
                    End If
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "キャンセルボタン."
        Private Sub Button1_Click( ByVal sender As System.Object, _
                                   ByVal e As System.EventArgs _
                                   ) Handles Btn_Cancel.Click
            Try
                Me.Close()
            Catch ex As Exception

            End Try
        End Sub
    #End Region
End Class