﻿Public Class Form3
    #Region "Class ClsEncodeInfo : エンコード情報用クラス."
        Public Class ClsEncodeInfo
            Dim Str_Name As String = Nothing            ' 名前.
            Dim Enc As System.Text.Encoding = Nothing   ' Text.Encoding.

            #Region "Sub New : リソースの割り当て."
                Sub New (ByVal ByVal_Name As String, ByVal ByVal_Enc As System.Text.Encoding)
                    Try
                        Str_Name = ByVal_Name
                        Enc = ByVal_Enc
                    Catch ex As Exception

                    End Try
                End Sub
            #End Region

            #Region "ReadOnly Property Encode : Text.Encoding."
                Public ReadOnly Property Encode() As System.Text.Encoding
                    Get
                        Return Enc
                    End Get
                End Property
            #End Region

            #Region "Overrides Function ToString : 名前を返します."
                Public Overrides Function ToString() As String
                    Return Str_Name.ToString()
                End Function
            #End Region
        End Class
    #End Region

    #Region "Sub Btn_OK_Click : OKボタンのクリック."
        Private Sub Btn_OK_Click( ByVal sender As System.Object, _
                                  ByVal e As System.EventArgs _
                                  ) Handles Btn_OK.Click
            Try
                ' ポート番号.
                ClsPub_POP3.Port = Me.NumericUpDown3.Value
                ' このサーバーは暗号化された接続(SSL)が必要.
                ClsPub_POP3.SSL = Me.Chk_SSL.Checked

                ' 受信タイムアウト.
                ClsPub_POP3.ReceiveTimeout = Me.NumericUpDown1.Value
                ' 送信時タイムアウト.
                ClsPub_POP3.SendTimeout = Me.NumericUpDown2.Value

                ' 認証設定.
                If Me.RadioButton1.Checked Then
                    ' NTLM-USER、PASS認証.
                    ClsPub_POP3.AttestationStyle = NSDPOP3.POP3_Attestation_Style.NTLM_UserPass
                ElseIf Me.RadioButton2.Checked Then
                    ' USER、PASS認証.
                    ClsPub_POP3.AttestationStyle = NSDPOP3.POP3_Attestation_Style.UserPassOnly
                Else
                    ' NTLM認証.
                    ClsPub_POP3.AttestationStyle = NSDPOP3.POP3_Attestation_Style.NTLM
                End If

                ' リスト設定.
                ClsPub_POP3.OneGetListCount = Me.NumericUpDown4.Value

                ’エンコーディングスタイル.
                ClsPub_POP3.EncodingStyle = Me.ComboBox1.SelectedIndex
                ' 不明の時に使用するエンコード方法.
                ClsPub_POP3.DefaultEncode = CType(Me.ComboBox2.SelectedItem, ClsEncodeInfo).Encode

                ' フォームをクローズします.
                Me.Close
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form3_Load : Loadイベント."
        Private Sub Form3_Load(ByVal sender As Object, _
                               ByVal e As System.EventArgs _
                               ) Handles Me.Load
            Try
                ' ポート番号.
                Me.NumericUpDown3.Value = ClsPub_POP3.Port
                ' このサーバーは暗号化された接続(SSL)が必要.
                Me.Chk_SSL.Checked = ClsPub_POP3.SSL

                ' 受信タイムアウト.
                Me.NumericUpDown1.Value = ClsPub_POP3.ReceiveTimeout
                ' 送信時タイムアウト.
                Me.NumericUpDown2.Value = ClsPub_POP3.SendTimeout

                ' 認証設定.
                Select Case ClsPub_POP3.AttestationStyle
                    Case NSDPOP3.POP3_Attestation_Style.NTLM_UserPass
                        ' NTLM-USER、PASS認証.
                        Me.RadioButton1.Checked = True
                    Case NSDPOP3.POP3_Attestation_Style.UserPassOnly
                        ' USER、PASS認証.
                        Me.RadioButton2.Checked = True
                    Case NSDPOP3.POP3_Attestation_Style.NTLM
                        ' NTLM認証.
                        Me.RadioButton3.Checked = True
                End Select

                ' リスト設定.
                Me.NumericUpDown4.Value = ClsPub_POP3.OneGetListCount

                ’エンコーディングスタイル.
                Me.ComboBox1.SelectedIndex = ClsPub_POP3.EncodingStyle
                ' 不明の時に使用するエンコード方法.
                With Me.ComboBox2
                    .Items.Clear
                    Dim Int_Index As Integer = -1
                    Dim Int_SelectIndex As Integer = -1

                    For Each EncInfo As System.Text.EncodingInfo In System.Text.Encoding.GetEncodings()
                        Dim SetEncInfo As System.Text.Encoding = EncInfo.GetEncoding
                        Dim Cls_Enc As New ClsEncodeInfo(SetEncInfo.EncodingName, SetEncInfo)
                        .Items.Add (Cls_Enc)
                        Int_Index += 1
                        If Cls_Enc.Encode Is ClsPub_POP3.DefaultEncode Then
                            Int_SelectIndex = Int_Index
                        End If
                    Next
                    If Int_SelectIndex <> -1 Then
                        .SelectedIndex = Int_SelectIndex
                    End If
                End With

            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region
End Class